#include <sys/stat.h>
#include <sys/dir.h>
#include <fcntl.h>

#include "config.h"

extern struct config config;

int comp(char *a, char *b)
{
	return strncmp(a, b, 6);
}

int getpage(char *no, char *data)
{
	char chstr[3], filename[256];
	int pagefd, sizelen, err;
	struct stat	fst;

	strncpy(chstr, no, 2);
	chstr[2] = '\0';
	sprintf(filename, "%s/%s/%s", config.spooldir, chstr, no+2);
//	printf("file = %s\n", filename);

	if((err = stat(filename, &fst)) == 0) {
		pagefd = open(filename, O_RDONLY| O_EXLOCK);
		fstat(pagefd, &fst);
		sprintf(data, "$%d\n", fst.st_size);
		sizelen = strlen(data);
		read(pagefd, data + sizelen, fst.st_size);
		close(pagefd);
		return sizelen + fst.st_size;
	} else {
//		printf("file stat error\n");
		strcpy(data, "&\n");
		return 2;
	}
}

getpagename(char *data)
{
	char		dirname[256], *dirdata, *filename, name[8];
	int		dirfd, count, size, i;
	long		offset;
	struct dirent	*p;

	sprintf(dirname, "%s/%02d", config.spooldir, config.captchan[0]);
//	printf("dir = %s\n", dirname);

	dirfd = open(dirname, O_RDONLY);

	dirdata = (char *)malloc(1024*16);
	filename = (char *)malloc(1024*64);
	*filename = '\0';
	count = 0;
	offset = 0;
	while((size = getdirentries(dirfd, dirdata, 1024*16, &offset)) > 0) {
		p = (struct dirent *)dirdata;
		for(i = 0; i < size; ++i) {
			if(p->d_fileno && p->d_namlen == 6) {
				strcat(filename, p->d_name);
				++count;
			}
			p = (struct dirent *)((int)p + p->d_reclen);
		}
	}

	qsort(filename, count, 6, comp);

	for(i = 0; i < count; ++i) {
		if(i)
			strcat(data, ",");
		strncat(data, filename + i * 6, 6);
	}
	strcat(data, "\n");

	free(filename);
	free(dirdata);
	close(dirfd);
}

readline(fd, ptr, maxlen)
int fd;
char *ptr;
int maxlen;
{
	int	n, rc;
	char	c;

	for(n = 1; n < maxlen; n++) {
		if((rc = read(fd, &c, 1)) == 1) {
			*ptr++ = c;
			if(c == '\n')
				break;
		} else if(rc == 0) {
			if(n == 1)
				return(0);
			else
				break;
		} else
			return(-1);
	}

	*ptr = 0;
	return(n);
}

#define MAXLINE 128

do_command(int sockfd)
{
	int	i, n, ch;
	char	command[MAXLINE], *resdata;
	int	pagefd, size;
	struct stat	fst;
	char	chstr[8], data[1024];

	for(;;) {
		n = readline(sockfd, command, MAXLINE);
		if(n == 0)
			return;
		switch(command[0]) {
		case 'Q':
			return;
		case 'C':
			*data = '$';
			*(data + 1) = '\0';
			for(i = 0; i < config.chancount; ++i) {
				if(i)
					strcat(data, ",");
				sprintf(chstr, "%02d", config.captchan[i]);
				strcat(data, chstr);
			}
			strcat(data, "\n");
			write(sockfd, data, strlen(data));
			break;
		case 'P':
			resdata = (char *)malloc(1024*16);
			strncpy(chstr, command + 1, 2);
			chstr[2] = '\0';
			ch = atoi(chstr);
			for(i = 0; i < config.chancount; ++i) {
				if(ch == config.captchan[i]) {
					resdata[0] = '$';
					getpagename(resdata);
					break;
				}
			}
			if(i == config.chancount) {
					strcpy(resdata, "&\n");
			}
			write(sockfd, resdata, strlen(resdata));
			free(resdata);
			break;
		case 'G':
			resdata = (char *)malloc(1024*8);
			if(*(command + strlen(command) - 2) == '\r')
				*(command + strlen(command) - 2) = '\0';
			else
				*(command + strlen(command) - 1) = '\0';
			size = -1;
			strncpy(chstr, command + 1, 2);
			chstr[2] = '\0';
			ch = atoi(chstr);
			for(i = 0; i < config.chancount; ++i) {
				if(ch == config.captchan[i]) {
					size = getpage(command + 1, resdata);
					break;	
				}
			}
			if(i == config.chancount) {
				strcpy(resdata, "&\n");
				size = 2;
			}
			write(sockfd, resdata, size);
			free(resdata);
			break;
		}

	}
}
