#include <stdio.h>
#include <sys/stat.h>
#include <sys/errno.h>

#include "config.h"

struct config config;

int getconfig()
{
	FILE *conf_fd;
	char *line, *top, chandir[256];
	struct stat fst;
	int i;

	config.chancount = 0;

	line = (char *)malloc(1924);
	conf_fd = fopen(CONFIG_FILE, "r");
	if(conf_fd == NULL) {
		printf("Can't open config file\n");
		exit(-1);
	}
	while(fgets(line, 1024, conf_fd) != NULL) {
		if((top = (char *)strtok(line, " \t\n")) != NULL) {
			if(strcmp(line, CAPTERCHANNEL) == 0) {
				while((top = (char *)strtok(NULL, ", \t\n")) != NULL) {
					config.captchan[config.chancount++] = atoi(top);
//					printf("%d\n", atoi(top));
				}
			}
			else if(strcmp(line, SERVERPORT) == 0) {
				if((top = (char *)strtok(NULL, ", \t\n")) != NULL) {
					config.port = atoi(top);
				} else {
					printf("Config file Error (%s)\n", line);
					exit(-1);
				}
			}
			else if(strcmp(line, SPOOLDIRCTORY) == 0) {
				top = (char *)strtok(NULL, " \t\n");
				if(*top == '"' && *(top + strlen(top) - 1) == '"') {
					strncpy(config.spooldir, top + 1, strlen(top) - 2);
					if(stat(config.spooldir, &fst) != 0) {
						printf("Can't open spool directory (%s)\n", config.spooldir);
						exit(-1);
					}		
				} else {
					printf("Config file Error (%s)\n", line);
					exit(-1);
				}
			}
		}
	}
	fclose(conf_fd);
	free(line);

	for(i = 0; i < config.chancount; i++) {
		sprintf(chandir, "%s/%02d", config.spooldir, config.captchan[i]);
		stat(chandir, &fst);
		if(errno == ENOENT) {
			mkdir(chandir, 0755);
		}
	}
}
