#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "config.h"

extern struct config config;

char *pname;

int sockfd;

sig_terminate()
{
	shutdown(sockfd, 2);
	exit(1);
}

sig_chiled()
{
	int status;

	while (0 < waitpid(-1, &status, WNOHANG)) ;
}

main(argc, argv)
int argc;
char *argv[];
{
	int			newsockfd, clilen, childpid;
	struct sockaddr_in	cli_addr, serv_addr;

	pname = argv[0];

	signal(SIGINT, (sig_t)sig_terminate);
	signal(SIGKILL, (sig_t)sig_terminate);
	signal(SIGCHLD, (sig_t)sig_chiled);

	getconfig();

	if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		printf("server: can't open steam socket\n");
		exit(-1);
	}

	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(config.port);

	if(bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
		printf("server: can't bind local address\n");
		exit(-1);
	}

	listen(sockfd, 5);

	for(;;) {
		clilen = sizeof(cli_addr);
		newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);

		if(newsockfd < 0) {
			printf("server: accept error\n");
			exit(-1);
		}

		if((childpid = fork()) < 0) {
			printf("server: fork error\n");
			exit(-1);
		}
		else if(childpid == 0) {
			close(sockfd);
			do_command(newsockfd);
			close(newsockfd);
			exit(0);
		}

		close(newsockfd);
	}
}
