/*
 */

#include <sys/fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <machine/ioctl_meteor.h>
#include <machine/ioctl_bt848.h>
#include <signal.h>
#include <setjmp.h>

#include "config.h"

#include "inbuf.h"

#define ROWS 240
#define COLS 320

#define TRANSMODE1	0x92
#define TRANSMODE2	0x2a
#define TRANSMODE3	0x46
#define TRANSMODE4	0xfe
#define TRANSASSIST	0x37

typedef unsigned char uint8;
typedef signed char int8;

extern int errno;

extern struct config config;

int bt848;
int scratch_file;
int tuner;
int vbi;

int ch;

int in_packet[4], is_header[4], next_ci[4], page_size[4];
unsigned char *page_buff[4];

void mojipacket(unsigned char *buff)
{
	int line, i, j, size, vbinum, crc;
	char filename[256];
	struct stat st;
	unsigned char data[22];
	int dumpfd;

	line = *buff;

	if(line >= 4 && line <= 6)
		vbinum = line - 4;
	else if(line == 11 || line == 23)
		vbinum = 3;
	else if(line >= 16 && line <= 18)
		vbinum = line - 16;
	else
		return;

	if(correct272(buff+1) == 0)
		return;

//	if(vbinum == 0) {
//		for(j = 0;j  < 35; ++j)
//			printf("%02x ", *(buff + j));
//		printf("\n");
//	}

	if(*(buff + 1) == TRANSMODE1 || *(buff + 1) == TRANSMODE2) {
//	if(*(buff + 1) == TRANSASSIST) {
//		printf("flug = %d packet = %d\n", (*(buff + 2) & 0x10) >> 4, in_packet[vbinum]);
		if((*(buff + 2) & 0x10) >> 4) {

			if(in_packet[vbinum]) {

				if(*(page_buff[vbinum] + 2) == 0x80)	// ???
					sprintf(filename, "%s/%02d/%1%1d%1d%1d01",
						config.spooldir, config.captchan[0],
						(*(page_buff[vbinum] + 10) >> 4) & 0x0f,
						*(page_buff[vbinum] + 10) & 0x0f,
						(*(page_buff[vbinum] + 11) >> 4) & 0x0f, 
						*(page_buff[vbinum] + 11) & 0x0f);
				else
					sprintf(filename, "%s/%02d/%1d%1d%1d%1d%1d%1d",
						config.spooldir, config.captchan[0],
						(*(page_buff[vbinum] + 10) >> 4)& 0x0f,
						*(page_buff[vbinum] + 10) & 0x0f,
						(*(page_buff[vbinum] + 11) >> 4) & 0x0f, 
						*(page_buff[vbinum] + 11) & 0x0f,
						(*(page_buff[vbinum] + 12) >> 4) & 0x0f,
						*(page_buff[vbinum] + 12) & 0x0f); 

//				if(stat(filename, &st))
//					unlink(filename);

				inbuf.buff = page_buff[vbinum];
				inbuf.size = page_size[vbinum];
				if(!checkLoop())
					printf("data group crc error %s\n", filename);
				else {
#if 1
					dumpfd = open(filename, O_CREAT | O_RDWR | O_TRUNC | O_EXLOCK, 0644);
					write(dumpfd, page_buff[vbinum], page_size[vbinum]);
					close(dumpfd);
#else
					printf("filename = %s\n", filename);
#endif
				}
				is_header[vbinum] = 1;
				next_ci[vbinum] = 0;
				page_size[vbinum] = 0;
			}
			else {
				in_packet[vbinum] = 1;
				is_header[vbinum] = 1;
				next_ci[vbinum] = 0;
				page_size[vbinum] = 0;
			}
		}
		if(in_packet[vbinum]) {
//			printf("%d %d %d\n", vbinum, next_ci[vbinum], *(buff + 2) & 0x0f);
			if(next_ci[vbinum] == (*(buff + 2) & 0x0f)) {
				next_ci[vbinum] = (next_ci[vbinum] + 1) & 0x0f;
				for(j = 0;j  < 22; ++j)
					data[j] = (*(buff + j + 3) & 0x3f) << 2 
						| ( 0xc0 & *(buff + j + 2)) >> 6;

				if(is_header[vbinum] == 1) {

					page_size[vbinum] = 0;

					is_header[vbinum] = 0;
					if(data[8] != 0x20) {
//						write(dumpfd[vbinum], data, 22);
						memcpy(page_buff[vbinum] + page_size[vbinum],
							data, 22);
						page_size[vbinum] += 22;
					}

				} else {
//					write(dumpfd[vbinum], data, 22);
					memcpy(page_buff[vbinum] + page_size[vbinum],
						data, 22);
					page_size[vbinum] += 22;
				}
			} else {
				in_packet[vbinum] = 0;
			}
		}
	}
}


sig_t done() {
	int c;
	c = METEOR_CAP_STOP_CONT;
	ioctl(vbi, METEORCAPTUR, &c);
	close(vbi);
	close(bt848);
        exit(0);
}

main(int ac, char **av)
{
	struct meteor_geomet geo;
	int c, size;
	int row, col, i;
	unsigned char *buff;

	getconfig();

	if ((bt848 = open("/dev/bktr0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}
	if ((tuner = open("/dev/tuner0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}
	if ((vbi = open("/dev/vbi0", O_RDONLY)) < 0) {
		printf("open failed: %d\n", errno);
		exit(1);
	}

	buff = (unsigned char *)malloc(1024 * 128);

	/* set up the capture type and size */

        i = 112;
        if (ioctl(bt848, METEORSCONT, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

        i = 0x70;
        if (ioctl(bt848, METEORSBRIG, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

	i = CHNLSET_JPNBCST;
        if (ioctl(tuner, TVTUNER_SETTYPE, &i) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

	ch = config.captchan[0];
        if (ioctl(tuner, TVTUNER_SETCHNL, &ch) < 0) {
                fprintf(stderr, "ioctl failed: %s\n", strerror(errno));
		exit(0);

        }

        geo.rows = ROWS;
        geo.columns = COLS;
	geo.frames = 1;
	geo.oformat = METEOR_GEO_RGB24 | METEOR_GEO_EVEN_ONLY; 
        if (ioctl(bt848, METEORSETGEO, &geo) < 0) {
		printf("ioctl failed: %d\n", errno);
		exit(1);
	}

	c = METEOR_INPUT_DEV1;
	if (ioctl(bt848, METEORSINPUT, &c) < 0) {
		printf("ioctl failed: %d\n", errno);
		exit(1);
	}

	signal(SIGINT,  (sig_t) done);
	c = 1;
	ioctl(bt848, BT848SCBUF, &c);


	for(i = 0; i < 4; ++i) {
		in_packet[i] = 0;
//		is_header[i] = 0;
		page_buff[i] = (unsigned char *)malloc(1024 * 16);
//		page_size[i] = 0;
	}

	c = METEOR_CAP_CONTINOUS;
	ioctl(vbi, METEORCAPTUR, &c);
	while(1) {
		size = read(vbi, buff, 1024 * 128);
		for(i = 0; i < size / 35; ++i) {
			mojipacket(buff + 35 * i);
		}
		usleep(100000);
	}

fine:

	close(vbi);
	close(tuner);
	close(bt848);

	free(buff);

	exit(0);
}

