

#include "inbuf.h"	/*inbuf*/

typedef unsigned char uchar;

static unsigned crcTbl[256] = {
#include "crctbl.h"
};

static unsigned crcReg;

static void
crc(int c)
{
	crcReg ^= (uchar)c;
	crcReg = (crcReg >> 8) ^ crcTbl[crcReg & 0xff];
}

static int verbose;

int
check(int n)
{
	crcReg = 0;
	/*printf("n = %d\n", n);*/
	for (; n > 0; n--) crc(inbufGetByte());
	if (verbose) printf("%04x\n", crcReg);
	if (inbuf.top[20] + inbuf.top[21]*256 != crcReg) {
		if (verbose) printf("CRC failed.\n");
//		exit(STAT_CRCFAIL); /* CRC failed */
		return 0;
    	}
	return 1;
}

int
checkLoop()
{
	inbufInit();
	while (inbufGetBlock()) {
		inbufSeek(0);
		if (inbuf.top[0] == 2) { /*STX*/
			if(!check( ((inbuf.top[3] & 0x7f) * 256 + inbuf.top[4] + 8 + 22-1)
				/ 22 * 22 - 2 )) return 0;
		} else { /*assuming SOH*/
			if(!check(20)) return 0;
		}
	}
	if (verbose) printf("CRC ok.\n");

	return 1;
}
